﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Drawing;
using SlimDX.Direct3D9;
using FDK;

namespace StrokeStyleT
{
	class CAct演奏コンボ : CActivity
	{
		public volatile int nCOMBO値;

		public CAct演奏コンボ()
		{
			this.list子Activities.Add( this.mAct単位付き数値 = new CMAct単位付き数値・ジャンプ() );
		}

		public override void On活性化( Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			this.e現在のモード = EMode.非表示中;
			this.nCOMBO値 = 0;
			this.n前のCOMBO値 = 0;
			this.nコンボが切れたときのCOMBO値 = 0;
			this.nコンボが切れた時刻 = CTimer.n未使用;

			base.On活性化( D3D9Device );
		}
		public override void OnManagedリソースの作成( Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			this.txCOMBOドラム = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenPlay combo.png" ) );
			if( this.txCOMBOドラム != null )
			{
				this.txCOMBOドラム.n透明度 = 180;

				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 0, 70 * 0, 45, 70 ) );	// 0
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 1, 70 * 0, 45, 70 ) );	// 1
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 2, 70 * 0, 45, 70 ) );	// 2
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 3, 70 * 0, 45, 70 ) );	// 3
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 4, 70 * 0, 45, 70 ) );	// 4
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 0, 70 * 1, 45, 70 ) );	// 5
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 1, 70 * 1, 45, 70 ) );	// 6
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 2, 70 * 1, 45, 70 ) );	// 7
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 3, 70 * 1, 45, 70 ) );	// 8
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 4, 70 * 1, 45, 70 ) );	// 9
				this.txCOMBOドラム.list描画範囲.Add( new Rectangle( 45 * 0, 70 * 2, 90, 32 ) );	// COMBO
			}

			base.OnManagedリソースの作成( D3D9Device );
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.txCOMBOドラム );

			base.OnManagedリソースの解放();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return 0;

			EEvent e今回の状態遷移イベント;

			#region [ 前回と今回の COMBO 値から、e今回の状態遷移イベントを決定する。]
			//-----------------
			int n前回の値 = this.n前のCOMBO値;
			int n今回の値 = this.nCOMBO値;

			if( n今回の値 < n表示可能な最小コンボ数 )
			{
				e今回の状態遷移イベント = EEvent.非表示;
			}
			else if( n前回の値 == n今回の値 )
			{
				e今回の状態遷移イベント = EEvent.同一数値;
			}
			else if( n前回の値 < n今回の値 )
			{
				e今回の状態遷移イベント = EEvent.数値更新;
			}
			else
			{
				e今回の状態遷移イベント = EEvent.ミス;
			}
			//-----------------
			#endregion

			this.n前のCOMBO値 = this.nCOMBO値;


		Retry:	// モードが変化した場合はここからリトライする。

			switch( this.e現在のモード )
			{
				case EMode.非表示中:
					#region [ 数値が更新されたら 進行表示中 モードへ。]
					//-----------------
					if( e今回の状態遷移イベント == EEvent.数値更新 )
					{
						this.e現在のモード = EMode.表示中;
						goto Retry;
					}
					this.mAct単位付き数値.b表示 = false;
					break;
					//-----------------
					#endregion

				case EMode.表示中:
					#region [ 遷移イベントが非表示・ミスのときは 残像表示中 モードへ。]
					//-----------------
					if( ( e今回の状態遷移イベント == EEvent.非表示 ) ||
						( e今回の状態遷移イベント == EEvent.ミス ) )
					{
						this.e現在のモード = EMode.残像表示中;
						this.nコンボが切れたときのCOMBO値 = n前回の値;
						this.nコンボが切れた時刻 = Global.rc演奏用タイマ.n現在時刻ms;
						goto Retry;
					}
					this.mAct単位付き数値.n数値 = n今回の値;
					this.mAct単位付き数値.b表示 = true;
					break;
					//-----------------
					#endregion

				case EMode.残像表示中:
					#region [ 数値が更新された場合は 進行表示中 モードへ、残像表示時間が切れたときは 非表示 モードへ。]
					//-----------------
					if( e今回の状態遷移イベント == EEvent.数値更新 )
					{
						this.e現在のモード = EMode.表示中;
						goto Retry;
					}
					else if( ( Global.rc演奏用タイマ.n現在時刻ms - this.nコンボが切れた時刻 ) > 1000 )
					{
						this.e現在のモード = EMode.非表示中;
						goto Retry;
					}
					this.mAct単位付き数値.n数値 = this.nコンボが切れたときのCOMBO値;
					this.mAct単位付き数値.b表示 = true;
					break;
					//-----------------
					#endregion
			}


			// 子Activityの進行。

			this.mAct単位付き数値.On進行();

			return 0;
		}
		public override void On描画( Device D3D9Device )
		{
			// 準正常・正常系チェック。

			if( this.b活性化してない ||
				this.txCOMBOドラム == null ||
				Global.Users.Config.ComboPosition == Eコンボ表示位置.OFF )
				return;


			// 描画。

			int n中央X = 300;
			switch( Global.Users.Config.ComboPosition )
			{
				case Eコンボ表示位置.LEFT: n中央X = 300; break;
				case Eコンボ表示位置.CENTER: n中央X = 440; break;
				case Eコンボ表示位置.RIGHT: n中央X = 680; break;
			}
			int n下辺Y = 130;	// Y座標は固定位置

			this.mAct単位付き数値.On描画( D3D9Device, this.txCOMBOドラム, n中央X, n下辺Y, CAct演奏コンボ.nドラムコンボの文字間隔 );
		}

		#region [ protected ]
		//-----------------
		protected CMAct単位付き数値・ジャンプ mAct単位付き数値 = null;
		protected CTexture txCOMBOドラム;
		protected EMode e現在のモード;
		protected int n前のCOMBO値 = 0;
		protected long nコンボが切れた時刻;
		protected int nコンボが切れたときのCOMBO値;

		// 定数

		protected enum EEvent { 非表示, 数値更新, 同一数値, ミス }
		protected enum EMode { 非表示中, 表示中, 残像表示中 }
		protected const int nドラムコンボの文字間隔 = 2;
		protected const int n表示可能な最小コンボ数 = 11;
		//-----------------
		#endregion
	}
}
